| API Documentation |  |

- MAIN PAGE
- NAMESPACES
- CLASSES

Classes | Public Member Functions | Static Public Member Functions | List of all members
nkWinUi::ContextMenu Class Referenceabstract

A graphical context menu. More...

Inheritance diagram for nkWinUi::ContextMenu:

## Classes
class | Item
| An item within the context menu component. More...

## Public Member Functions
| ContextMenu (System *system) noexcept
virtual | ~ContextMenu ()
Component * | getParentComponent () const
virtual Item * | getItem (unsigned int index) const =0
virtual unsigned int | getItemCount () const =0
void | setAutomaticSizing (bool value)
virtual Item * | addItem (nkMemory::StringView label, std::function< void()> callback)=0
virtual void | addSeparator ()=0
virtual void | clearItems ()=0
virtual void | pop ()=0
virtual void | recomputeSizeToFitItems ()=0
virtual void | exportClassToTree (nkExport::Node *rootNode) override
virtual void | importClassFromTree (nkExport::Node *rootNode) override
Public Member Functions inherited from nkWinUi::Component
| Component (System *system) noexcept
virtual | ~Component ()
Layout * | getLayout () const
Theme * | getTheme () const
Font * | getFont () const
nkMaths::Point | getPositionInParent () const
nkMaths::Point | getPositionInScreen () const
float | getWidth () const
float | getHeight () const
nkMaths::Rectangle | getAreaInParent () const
nkMaths::Rectangle | getAreaInScreen () const
virtual nkMaths::Point | getBorderExtents () const
virtual float | getBorderExtent (BORDER_KIND border) const
virtual float | getLayoutAllowedWidth () const
virtual float | getLayoutAllowedHeight () const
virtual float | getLayoutAllowedOffsetX () const
virtual float | getLayoutAllowedOffsetY () const
bool | isInitialized () const
System * | getSystem () const
Component * | getParentComponent () const
COMPONENT_TYPE | getComponentType () const
nkMemory::StringView | getComponentName () const
bool | getVisibility () const
virtual nkMemory::StringView | getLabel () const
void * | getData () const
bool | isEnabled () const
bool | isForegroundWindow () const
virtual unsigned int | getZDepth () const
bool | getVisibleOnLoad () const
std::function< bool(Component *)> | getCloseCallback () const
std::function< void(Component *, bool)> | getVisibilityCallback () const
std::function< void(Component *, const ClickEventData &)> | getClickCallback () const
std::function< void(Component *, const WheelEventData &)> | getWheelCallback () const
std::function< void(Component *, const KeyEventData &)> | getKeyCallback () const
virtual Layout * | setLayout (LAYOUT_TYPE layoutType)
virtual void | setTheme (Theme *theme)
virtual void | setFont (Font *font)
virtual void | setPositionInParent (nkMaths::Point position)
virtual void | setPositionInScreen (nkMaths::Point position)
virtual void | setSize (float width, float height)
virtual void | setWidth (float width)
virtual void | setHeight (float height)
void | setMinSize (float width, float height)
void | setMaxSize (float width, float height)
void | setRatio (float widthOverHeight)
virtual void | setAreaInParent (const nkMaths::Rectangle &area)
virtual void | setAreaInScreen (const nkMaths::Rectangle &area)
virtual void | setParentComponent (Component *parent, bool makeItVisible=true)
virtual void | setLabel (nkMemory::StringView label)
void | setComponentName (nkMemory::StringView name)
virtual void | setVisibility (bool value)
void | setData (void *data)
void | setEnabled (bool value)
void | setVisibleOnLoad (bool value)
void | setCloseCallback (std::function< bool(Component *caller)> callback)
void | setVisibilityCallback (std::function< void(Component *caller, bool visibility)> callback)
void | setClickCallback (std::function< void(Component *caller, const ClickEventData &eventData)> callback)
void | setWheelCallback (std::function< void(Component *caller, const WheelEventData &eventData)> callback)
void | setKeyCallback (std::function< void(Component *caller, const KeyEventData &eventData)> callback)
void | addChild (Component *child, bool makeItVisible=true)
void | removeChild (Component *child)
void | removeChild (unsigned int index)
Component * | getChild (unsigned int index)
unsigned int | getChildIndex (Component *child)
void | unloadWithChildren ()
void | loadWithChildren ()
void | updateZDepth ()
void | bringToForeground ()
void | focusWindow ()
nkMaths::Point | getCoordRelativeFromAbsolute (nkMaths::Point absCoords)
nkMaths::Point | getCoordAbsoluteFromRelative (nkMaths::Point relCoords)
virtual void | load ()=0
virtual void | unload ()=0
void | reload ()
virtual void | updateWindow ()
nkImages::Image | paintToImage (bool withFrame=false)
void | simulateEvent (const InputDescriptor &inputDescription)
virtual void | onSized ()
virtual void | exportIntrospection (nkExport::Node *rootNode)
Public Member Functions inherited from nkExport::Exportable
| Exportable () noexcept
virtual | ~Exportable ()

## Static Public Member Functions
static nkMemory::UniquePtr< ContextMenu > | create (System *system=nullptr)

## Detailed Description

A graphical context menu.

## Constructor & Destructor Documentation

## ◆ ContextMenu()

nkWinUi::ContextMenu::ContextMenu | ( | System * | system | ) |
| noexcept

Constructor.

Parameters

  system | The parent system in which the component will live.

Remarks
  See ComponentManager::createOrRetrieve().

## ◆ ~ContextMenu()

virtual nkWinUi::ContextMenu::~ContextMenu | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ getParentComponent()

Component* nkWinUi::ContextMenu::getParentComponent | ( |  | ) | const

Returns
  The parent component of the context menu.

## ◆ getItem()

virtual Item* nkWinUi::ContextMenu::getItem | ( | unsigned int | index | ) | const
| pure virtual

Getter for a given item.

Parameters

  index | The index of the item to retrieve.

Returns
  The item at given index if available, nullptr otherwise.

Remarks
  A separator will also return nullptr, currently. As such, to loop over all items, be sure to get the item count via the right getter.

## ◆ getItemCount()

virtual unsigned int nkWinUi::ContextMenu::getItemCount | ( |  | ) | const
| pure virtual

Returns
  The number of items displayed by the menu.

## ◆ setAutomaticSizing()

void nkWinUi::ContextMenu::setAutomaticSizing | ( | bool | value | ) |

Sets whether the menu should auto size itself when popping out. This will ensure the menu is having the right size for the items it showcases.

Parameters

  value | If the menu should auto size itself (true) or not (false).

## ◆ addItem()

virtual Item* nkWinUi::ContextMenu::addItem | ( | nkMemory::StringView | label,
|  | std::function< void()> | callback
| ) |  |
| pure virtual

Adds an item to the menu. In the menu, items appear in the order they are declared.

Parameters

  label | The label of the item to create.
  callback | The callback if the item is clicked while the menu is displayed.

Returns
  The item newly created.

## ◆ addSeparator()

virtual void nkWinUi::ContextMenu::addSeparator | ( |  | ) |
| pure virtual

Adds a separator.

## ◆ clearItems()

virtual void nkWinUi::ContextMenu::clearItems | ( |  | ) |
| pure virtual

Clear all items registered in the menu to start fresh.

## ◆ pop()

virtual void nkWinUi::ContextMenu::pop | ( |  | ) |
| pure virtual

Makes the item pop on screen.

Remarks
  While the setVisibility() method could be used, this pop() method will also do some menu related processing (sizing, ...).

## ◆ recomputeSizeToFitItems()

virtual void nkWinUi::ContextMenu::recomputeSizeToFitItems | ( |  | ) |
| pure virtual

Recomputes the component's area to fit the items currently registered. Can be called to manually trigger an automatic sizing.

## ◆ exportClassToTree()

virtual void nkWinUi::ContextMenu::exportClassToTree | ( | nkExport::Node * | rootNode | ) |
| override virtual

A basic exporting capability.

Parameters

  rootNode | The root of the tree to export into.

Reimplemented from nkWinUi::Component.

## ◆ importClassFromTree()

virtual void nkWinUi::ContextMenu::importClassFromTree | ( | nkExport::Node * | rootNode | ) |
| override virtual

A basic importing capability.

Parameters

  rootNode | The root of the tree to import from.

Reimplemented from nkWinUi::Component.

## ◆ create()

static nkMemory::UniquePtr<ContextMenu> nkWinUi::ContextMenu::create | ( | System * | system = `nullptr` | ) |
| static

Creates a standalone component, linking it to a system, but no manager. This method can be used to allocate a component and manually manage its lifetime.

Parameters

  system | The system to create the component into. If left to nullptr, then the Singleton instance will be used.

Returns
  The created component instance.

The documentation for this class was generated from the following file:

- Documentation/Headers/NilkinsWinUi/Components/ContextMenu.h